/**
 * StatServer
 *
 * LICENSE
 *
 * "THE BEER-WARE LICENSE" (Revision 42):
 * "Sven Strittmatter" <strittmatter@sven-space.de> wrote this file.
 * As long as you retain this notice you can do whatever you want with
 * this stuff. If we meet some day, and you think this stuff is worth it,
 * you can buy me a beer in return.
 *
 * @category    StatServer
 * @package     JavaScript
 * @copyright   Copyright (c) 2006 Sven Strittmatter
 */

/*global PeriodicalExecuter, Event, cpaint */

(function() {

    // some global vars:
    var serverskript  = 'server.php';
    var cpaint_client = new cpaint();
    var services      = new Array();

    /**
     * Function to refresh the server statuses.
     */
    function refreshServisStats() {
        for (var i = 0; i < services.length; i++) {
            getServiceStatus(services[i]);
        }
    }

    /**
     * Reomte call wrapper for getServices.
     */
    function getServices() {
        cpaint_client.call(serverskript, 'getServices', displayServices);
    }

    /**
     * Reomte call wrapper for getServiceStatus.
     */
    function getServiceStatus(service) {
        cpaint_client.call(serverskript, 'getServiceStatus', displayServiceStatus, service);
    }

    /**
     * Calback for displaying services initial.
     *
     * response in JSON:
     * <code>
     * var response = {
     *	"attributes": {"id": ""},
     *	"data": ["www.sven-space.de", "milesoft.dyndns.info"]
     * };
     * </code>
     */
    function displayServices(result) {
        var out = '<table>';
        out += '<tr><th>Service</th><th>Status</th></tr>';

        for (var i = 0; i < result.data.length; i++) {
            services.push(result.data[i]);
            out += '<tr><td>' + result.data[i] + '</td><td id="' + result.data[i] + '">offline</td></tr>';
        }

        out += '</table>';

        $('status_table').innerHTML = out;
        // show actual satus
        refreshServisStats();
        // refresh status periodacly
        new PeriodicalExecuter(refreshServisStats, 30);
    }

    /**
     * Callback for displaying service status.
     *
     * response in JSON:
     * <code>
     * var response = {
     *	"attributes": {
     *		"id": ""
     *	},
     *	"data": {
     *		"milesoft.dyndns.info": 1
     *	}
     * };
     * </code>
     */
    function displayServiceStatus(result) {
        $(result.data.name).innerHTML = (1 === result.data.status) ? 'online' : 'offline';
    }

    /******************************************************************************
     #######################  Here comes the client code. #########################
     ******************************************************************************/
    cpaint_client.set_debug(-1);
    cpaint_client.set_persistent_connection(false);
    cpaint_client.set_response_type('JSON');
    cpaint_client.set_transfer_mode('POST');
    Event.observe(window, 'load', getServices, false);

})();